﻿package classes {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	public class Doll extends Sprite {
		
		private var _body:Segment;
		private var _legLeft1:Segment;
		private var _legLeft2:Segment;
		private var _legRight1:Segment;
		private var _legRight2:Segment;
		private var _handLeft1:Segment;
		private var _handLeft2:Segment;
		private var _handRight1:Segment;
		private var _handRight2:Segment;
		private var _head:Sprite;
		private var _bodyangle:Number = 0;
		private var _cycle:Number = 0;
		private var _main:Main;
		private var _bassFlg:Boolean = false;
		private var _hihatFlg:Boolean = false;
		
		private var _color:uint = 0xFFFFFF;
		
		public function Doll($main) {
			_main = $main;
			init();
		}
		
		private function init():void{
			_body = new Segment( 100 , 50 , _color,true);
			addChildAt(_body ,0);
			_body.x = 0;
			_body.y = -70;
			
			_legLeft1 = new Segment( 20 , 40 , _color);
			addChildAt(_legLeft1 ,0);
			_legLeft1.x = _body.getPin3().x;
			_legLeft1.y = _body.getPin3().y;
			
			_legLeft2 = new Segment( 20 , 40 , _color);
			addChildAt(_legLeft2 ,0);
			_legLeft2.x = _legLeft1.getPin().x;
			_legLeft2.y = _legLeft1.getPin().y;
			
			_legRight1 = new Segment( 20 , 40 , _color);
			addChildAt(_legRight1 ,0);
			_legRight1.x = _body.getPin4().x;
			_legRight1.y = _body.getPin4().y;
			
			_legRight2 = new Segment( 20 , 40 , _color);
			addChildAt(_legRight2 ,0);
			_legRight2.x = _legRight1.getPin().x;
			_legRight2.y = _legRight1.getPin().y;
			
			_handLeft1 = new Segment( 20 , 40 , _color);
			addChildAt(_handLeft1 ,0);
			_handLeft1.x = _body.getPin1().x;
			_handLeft1.y = _body.getPin1().y;
			_handLeft1.rotation = 50;
			
			_handLeft2 = new Segment( 20 , 40 , _color);
			addChildAt(_handLeft2 ,0);
			_handLeft2.x = _handLeft1.getPin().x;
			_handLeft2.y = _handLeft1.getPin().y;
			
			_handRight1 = new Segment( 20 , 40 , _color);
			addChildAt(_handRight1 ,0);
			_handRight1.x = _body.getPin2().x;
			_handRight1.y = _body.getPin2().y;
			_handRight1.rotation = -50;
			
			_handRight2 = new Segment( 20 , 40 , _color);
			addChildAt(_handRight2 ,0);
			_handRight2.x = _handRight1.getPin().x;
			_handRight2.y = _handRight1.getPin().y;
			
			_head = new Sprite();
			addChild(_head);
			_head.graphics.lineStyle(0);
			_head.graphics.beginFill( _color , 1 );
			_head.graphics.drawCircle( 0, 0, 30 );
			_head.x = _body.getPin5().x;
			_head.y = _body.getPin5().y;
			
			addEventListener( Event.ENTER_FRAME , onEnterFrameHandler );
			_main.addEventListener(_main.HIHAT , _hihatHandler );
			_main.addEventListener(_main.SNARE , _snareHandler );
			_main.addEventListener(_main.BASS , _bassHandler );
		}
		
		private function onEnterFrameHandler(e:Event):void {
			
			//_cycle += 0.1;
			//_bodyangle += 0.1;
			_body.y += ( -70 - _body.y ) / 20;
			
			_body.rotation += getvRot(_body.rotation);
			
			_legLeft1.rotation += getvRot(_legLeft1.rotation + _body.rotation);
			_legLeft1.x = _body.getPin3().x;
			_legLeft1.y = _body.getPin3().y;
			
			_legLeft2.rotation += getvRot(_legLeft2.rotation);
			_legLeft2.x = _legLeft1.getPin().x;
			_legLeft2.y = _legLeft1.getPin().y;
			
			_legRight1.rotation += getvRot(_legRight1.rotation + _body.rotation);
			_legRight1.x = _body.getPin4().x;
			_legRight1.y = _body.getPin4().y;
			
			_legRight2.rotation += getvRot(_legRight2.rotation);
			_legRight2.x = _legRight1.getPin().x;
			_legRight2.y = _legRight1.getPin().y;
			
			_handLeft1.rotation += getvRot(_handLeft1.rotation + _body.rotation , 50);
			_handLeft1.x = _body.getPin1().x;
			_handLeft1.y = _body.getPin1().y;
			
			_handLeft2.rotation += getvRot(_handLeft2.rotation);
			_handLeft2.x = _handLeft1.getPin().x;
			_handLeft2.y = _handLeft1.getPin().y;
			
			_handRight1.rotation += getvRot(_handRight1.rotation + _body.rotation , -50);
			_handRight1.x = _body.getPin2().x;
			_handRight1.y = _body.getPin2().y;
			
			_handRight2.rotation += getvRot(_handRight2.rotation);
			_handRight2.x = _handRight1.getPin().x;
			_handRight2.y = _handRight1.getPin().y;

			_head.x = _body.getPin5().x;
			_head.y = _body.getPin5().y;
		}
		
		private function getvRot(rot:Number , defalft:Number=0):Number {
			var vrot:Number = (defalft - rot) / 20;
			return vrot;
		}
		
		private function _hihatHandler(e:Event):void {
			_hihatFlg = !_hihatFlg;
			
			_legLeft1.rotation = 60;
			_legRight1.rotation = -60;
			_handLeft1.rotation = 100;
			_handRight1.rotation = -100;
			
			
			/*
			if (_hihatFlg) {
				_handLeft2.rotation = 180;
				_handLeft1.rotation += 30;
				_legRight2.rotation += 60;
			} else {
				_handRight2.rotation = -180;
				_handRight1.rotation -= 30;
				_legLeft2.rotation += -60;
			}
			*/
		}
		
		private function _snareHandler(e:Event):void {

			
			_body.y = -100;
		}
		
		private function _bassHandler(e:Event):void {
			_bassFlg = !_bassFlg;
			
			if (_bassFlg) {
				_body.rotation = 30;
			} else {
				_body.rotation = -30;
			}
		}
		private function walk(segA:Segment, segB:Segment, cyc:Number):void
		{
			var Range:Number = 45;
			var Base:Number = 0;
			var Offset:Number = -1.57;
			var foot:Point = segB.getPin();
			var angleA:Number = Math.sin(cyc) *	Range + Base;
			var angleB:Number = Math.sin(cyc + Offset) *	Range +	Base;
			segA.rotation = angleA;
			segB.rotation = segA.rotation + angleB;
			segB.x = segA.getPin().x;
			segB.y = segA.getPin().y;
			//segB.vx = segB.getPin().x - foot.x;
			//segB.vy = segB.getPin().y - foot.y;
		}
	}
	
}