﻿package classes {
	import flash.display.Sprite;
	import flash.events.Event;
	import caurina.transitions.Tweener;
	
	public class Main extends Sprite {
		
		private var _metronome:Metronome;
		private var _score:Score;
		private var _bpmTextField:BpmTextField;
		private var _startBtn:StartBtn;
		private var _onpuArray:Array;
		private var _soundManage:SoundManage;
		private var _doll:Doll;
		public const HIHAT:String = "hihat";
		public const SNARE:String = "snare";
		public const BASS:String = "bass";
		
		public function Main() {
			init();
		}
		
		private function init():void {
			
			_score = new Score();
			addChild(_score);
			_score.x = 50;
			_score.y = stage.stageHeight - 110;
			
			_bpmTextField = new BpmTextField();
			addChild(_bpmTextField);
			_bpmTextField.x = 500;
			_bpmTextField.y = stage.stageHeight - 110;
			
			_startBtn = new StartBtn();
			addChild(_startBtn);
			_startBtn.x = 500;
			_startBtn.y = stage.stageHeight - 80;
			
			_doll = new Doll(this);
			addChild(_doll);
			_doll.x = stage.stageWidth/2;
			_doll.y = stage.stageHeight/2;
			
			_metronome = new Metronome();
			_soundManage = new SoundManage(this);
			
			_startBtn.addEventListener( _startBtn.START , start );
			_startBtn.addEventListener( _startBtn.STOP , stop );
		}
		
		private function start(e:Event):void {
			var bpm:Number = _bpmTextField.getBpm();
			_onpuArray = _score.onpuArray;
			_metronome.addEventListener( _metronome.BEAT8 , beat8Handler );
			_metronome.start( bpm );
		}
		
		private function stop(e:Event):void {
			_metronome.stop();
			_metronome.removeEventListener( _metronome.BEAT8 , beat8Handler );
		}
		
		private function beat8Handler(e:Event):void {
			var count:Number = e.target.count;
			if ( _onpuArray[count][0].checked ) {
				dispatchEvent( new Event(HIHAT) );
			}
			if ( _onpuArray[count][1].checked ) {
				dispatchEvent( new Event(SNARE) );
			}
			if ( _onpuArray[count][2].checked ) {
				dispatchEvent( new Event(BASS) );
			}
			
			for (var i:int = 0; i < 3; i++) {
				Tweener.addTween( _onpuArray[count][i]._rect , {
					alpha:0.5
				});
				Tweener.addTween( _onpuArray[count][i]._rect , {
					alpha:0.2 ,
					time : 0.5
				});
			}
		}
		
	}
	
}