﻿package classes {
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	
	public class Metronome extends EventDispatcher {
		
		private var _beat8Time:Number;
		private var _count:Number = 0;
		private var _time:Timer;
		public const BEAT8:String = "beat8";
		
		public function Metronome() {
			
		}
		
		public function start($bpm:Number = 60) {
			//テンポの計算
			//60  / テンポ（四分音符） * 音符の長さ
			_count = 0;
			_beat8Time = Math.round(60 / $bpm * 0.5 * 1000);
			_time = new Timer(_beat8Time);
			_time.addEventListener( TimerEvent.TIMER , onTimeCompleteHandler );
			_time.start();
		}
		
		private function onTimeCompleteHandler(e:TimerEvent):void {
			
			if (_count % 1 == 0) {
				dispatchEvent( new Event( BEAT8 ) );
			}
			
			/*
			if (_count % 2 == 0) {
				trace("4分音符");
			}
			
			if (_count % 4 == 0) {
				trace("2分音符");
			}
			
			if (_count % 8 == 0) {
				trace("全音符");
			}
			*/
			_count++;
			if (_count >= 8) {
				_count = 0;
			}
		}
		
		public function stop() {
			_time.removeEventListener( TimerEvent.TIMER , onTimeCompleteHandler );
		}
		
		public function get count():Number { return _count; }
		
	}
	
}