﻿package classes {
	import flash.display.Sprite;
	import flash.geom.Point;

	public class Segment extends Sprite
	{
		private var color:uint;
		private var segmentWidth:Number;
		private var segmentHeight:Number;
		private var pin4:Boolean = false;
		
		public var vx:Number = 0;
		public var vy:Number = 0;
		
		public function Segment(segmentWidth:Number, segmentHeight:Number, color:uint = 0xffffff , pin4:Boolean = false)
		{
			this.segmentWidth = segmentWidth;
			this.segmentHeight = segmentHeight;
			this.color = color;
			this.pin4 = pin4;
			init();
		}
		
		public function init():void
		{
			// セグメント自体の描画
			graphics.lineStyle(0);
			graphics.beginFill(color);
			graphics.drawRoundRect(-segmentWidth / 2, 
								   -segmentWidth / 2,
								   segmentWidth,
								   segmentWidth + segmentHeight,
								   segmentWidth,
								   segmentWidth);
			graphics.endFill();
			

			if (pin4) {
				// 4つの“ピン”の描画
				graphics.drawCircle( -segmentWidth / 4 , 0 , 2 );
				graphics.drawCircle( segmentWidth / 4 , 0 , 2 );
				graphics.drawCircle( -segmentWidth / 4 , segmentHeight , 2 );
				graphics.drawCircle( segmentWidth / 4 , segmentHeight , 2 );
				graphics.drawCircle( 0 , -segmentHeight/4 , 2 );
			} else {
				// 2つの“ピン”の描画
				graphics.drawCircle(0, 0, 2);
				graphics.drawCircle(0, segmentHeight, 2);
			}

		}
		
		public function getPin():Point
		{	
			var angle:Number = ( 90 + rotation) * Math.PI / 180;
			var xPos:Number = x + Math.cos(angle) * segmentHeight;
			var yPos:Number = y + Math.sin(angle) * segmentHeight;
			return new Point(xPos, yPos);
		}
		
		public function getPin1():Point
		{
			var angle:Number = rotation * Math.PI / 180;
			var xPos:Number = x + Math.cos(angle) * -segmentWidth/4;
			var yPos:Number = y + Math.sin(angle) * -segmentWidth/4;
			return new Point(xPos, yPos);
		}
		
		public function getPin2():Point
		{
			var angle:Number = rotation * Math.PI / 180;
			var xPos:Number = x + Math.cos(angle) * segmentWidth/4;
			var yPos:Number = y + Math.sin(angle) * segmentWidth /4;
			return new Point(xPos, yPos);
		}
		
		public function getPin3():Point
		{
			var len:Number = Math.sqrt( segmentWidth/4 * segmentWidth/4 + segmentHeight * segmentHeight);
			var rot:Number = Math.atan2( segmentHeight , -segmentWidth/4 ) * 180 / Math.PI;
			var angle:Number = (rotation + rot) * Math.PI / 180;
			var xPos:Number = x + Math.cos(angle) * len;
			var yPos:Number = y + Math.sin(angle) * len;
			return new Point(xPos, yPos);
		}
		
		public function getPin4():Point
		{
			var len:Number = Math.sqrt( -segmentWidth/4 * -segmentWidth/4 + segmentHeight * segmentHeight);
			var rot:Number = Math.atan2( segmentHeight , segmentWidth/4 ) * 180 / Math.PI;
			var angle:Number = (rotation + rot) * Math.PI / 180;
			var xPos:Number = x + Math.cos(angle) * len;
			var yPos:Number = y + Math.sin(angle) * len;
			return new Point(xPos, yPos);
		}
		
		public function getPin5():Point
		{	
			var angle:Number = ( -90 + rotation)  * Math.PI / 180;
			var xPos:Number = x + Math.cos(angle) * segmentHeight/4;
			var yPos:Number = y + Math.sin(angle) *  segmentHeight/4;
			return new Point(xPos, yPos);
		}
	}
}