﻿package classes {
	import flash.display.Sprite;
	import flash.display.GradientType;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.events.MouseEvent;
	
	public class StartBtn extends Sprite {
		
		private var _bg:Sprite;
		private var _btnText:Sprite;
		private var _startchecked:Boolean = false;
		public const START:String = "start";
		public const STOP:String = "stop";
		
		public function StartBtn() {
			init();
		}
		
		private function init():void{
			_bg = new Sprite();
			addChild(_bg);
			bgDraw(false);
			
			_btnText = new BtnStart();
			addChild(_btnText);
			_btnText.x = _bg.width / 2;
			_btnText.y = 6;
			
			this.buttonMode = true;
			
			this.addEventListener(MouseEvent.ROLL_OVER , onRollOverHandler );
			this.addEventListener(MouseEvent.ROLL_OUT , onRollOutHandler );
			this.addEventListener(MouseEvent.CLICK , onClickHandler );
		}
		
		private function bgDraw(rollOver:Boolean):void {
			_bg.graphics.clear();
			var matrix:Matrix = new Matrix();
			matrix.scale( 0.05 , 1);
			matrix.translate( 0 , 0);
			matrix.rotate( Math.PI / 180 * 90 );
			_bg.graphics.lineStyle( 1 , 0xcccccc , 0.2 , true );
			
			if (!rollOver) {
				_bg.graphics.beginGradientFill(
				GradientType.LINEAR ,
				[0x333333 ,  0x0] ,
				[1 , 1 ] ,
				[128 , 255 ] ,
				matrix
				);
			} else {
				_bg.graphics.beginGradientFill(
				GradientType.LINEAR ,
				[0x666666 ,  0x0] ,
				[1 , 1 ] ,
				[128 , 255 ] ,
				matrix
				);
			}

			_bg.graphics.drawRoundRect( 0 , 0 , 120, 30 , 18 ,18);
			_bg.graphics.endFill();
		}
		
		private function onRollOverHandler(e:MouseEvent):void {
			bgDraw(true);
		}
		
		private function onRollOutHandler(e:MouseEvent):void {
			bgDraw(false);
		}
		
		private function onClickHandler(e:MouseEvent):void {
			_startchecked = !_startchecked;
			
			removeChild(_btnText);
			if (_startchecked) {
				dispatchEvent( new Event(START) );
				_btnText = new BtnStop();
			} else {
				dispatchEvent( new Event(STOP) );
				_btnText = new BtnStart();
			}
			addChild(_btnText);
			_btnText.x = _bg.width / 2;
			_btnText.y = 6;
		}
	}
	
}